/* Problem URL: https://codeforces.com/problemset/problem/1747/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    int n, q;
    cin >> n >> q;

    vi a(n);
    cin >> a;

    vi pref(n + 1);
    vi zero(n + 1);
    unordered_map<int, vi> var;
    unordered_map<int, vi> odd;
    unordered_map<int, vi> even;
    rep(i, n) {
        pref[i + 1] = pref[i] ^ a[i];
        zero[i + 1] = zero[i] + (a[i] == 0);
        var[pref[i + 1]].push_back(i);
        if (i & 1) {
            odd[pref[i + 1]].push_back(i);
        } else {
            even[pref[i + 1]].push_back(i);
        }
    }


    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;

        if (zero[r + 1] - zero[l] == r - l + 1) {
            cout << "0\n";
            continue;
        }

        if (r - l <= 1) {
            cout << "-1\n";
            continue;
        }

        int xo = pref[r + 1] ^ pref[l];
        if (xo != 0) {
            cout << "-1\n";
            continue;
        }

        if ((r - l + 1) & 1) {
            cout << "1\n";
            continue;
        }

        auto fds = var.find(pref[r + 1]);
        if (fds == var.end()) {
            cout << "-1\n";
        }

        vi &tmp = fds->second;
        auto one = lower_bound(all(tmp), l);
        auto two = lower_bound(all(tmp), r);

        if (two != tmp.begin()) {
            two--;
        }

        if ((one != tmp.end() && *one == l) || (two != tmp.end() && *two == r - 1)) {
            cout << "1\n";
            continue;
        }

        if (r & 1) {
            vi &act = even[pref[r + 1]];
            auto itr = lower_bound(all(act), l);
            if (itr == act.end() || *itr > r) {
                cout << "-1\n";
                continue;
            }
        } else {
            vi &act = odd[pref[r + 1]];
            auto itr = lower_bound(all(act), l);
            if (itr == act.end() || *itr > r) {
                cout << "-1\n";
                continue;
            }
        }

        cout << "2\n";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
